/*globals define*/

define([
    'testsuite/qunit',
    'jquery',

    'de_epages/seo/ui/seogaugewidget',
    '$ready!'
], function (QUnit, $) {
    'use strict';

    QUnit.module("de_epages/seo/ui/seogaugewidget");

    QUnit.test("de_epages/seo/ui/seogaugewidget", function () {

        var elem = $('#qunit-fixture').seoUiSeoGaugeWidget({
            'seoQuality': 15
        });

        QUnit.ok(elem, 'widget ok');

        QUnit.ok(!$('.de_epages-seoUiSeoGaugeWidget-itemStatus').hasClass('HideElement'), 'status image ok');

        elem.seoUiSeoGaugeWidget('showStatusImage', false);
        QUnit.ok($('.de_epages-seoUiSeoGaugeWidget-itemStatus').hasClass('HideElement'), 'status image ok');

        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'seoQuality'), 15, 'percentage value ok');

        elem.seoUiSeoGaugeWidget('setPercentage', 0);
        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'seoQuality'), 0, 'percentage value ok');

        elem.seoUiSeoGaugeWidget('setPercentage', 45);
        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'seoQuality'), 45, 'percentage value ok');

        elem.seoUiSeoGaugeWidget('setPercentage', 90);
        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'seoQuality'), 90, 'percentage value ok');

        elem.seoUiSeoGaugeWidget('setPercentage', 100);
        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'seoQuality'), 100, 'percentage value ok');

        elem.seoUiSeoGaugeWidget('setDeactivated', true);
        QUnit.equal(elem.seoUiSeoGaugeWidget('option', 'deactivated'), true, 'value of deactivated has changed');
    });
});