define(['testsuite/qunit', 'jquery', 'de_epages/presentation/history', '$ready!'], function (QUnit, $, de_epages) {

	QUnit.module("de_epages/presentation/history");

	QUnit.asyncTest("de_epages/presentation/history", function() {

		var historyHandle = de_epages.presentation.history;
		
		historyHandle.remove();
		
		// add current
		historyHandle.add();
		
		QUnit.deepEqual(
			historyHandle.get(),
			[ { "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" } ],
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(0),
			{ "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" },
			'historyHandle.get() == [...]'
		);
		
		// add additional
		historyHandle.add({
			objectId: 6789,
			viewAction: 'MBO-ViewHistory'
		});
		
		QUnit.deepEqual(
			historyHandle.get(),
			[ { "objectId": 6789, "viewAction": "MBO-ViewHistory", "id": "6789:MBO-ViewHistory", "title": "" }, { "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" } ],
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(0),
			{ "objectId": 6789, "viewAction": "MBO-ViewHistory", "id": "6789:MBO-ViewHistory", "title": "" },
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(1),
			{ "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" },
			'historyHandle.get() == [...]'
		);
		
		// remove additional
		historyHandle.remove(1);
		
		QUnit.deepEqual(
			historyHandle.get(),
			[ { "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" } ],
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(0),
			{ "title": "", "objectId": 0, "viewAction": "MBO-ViewTestcase", "id": "0:MBO-ViewTestcase" },
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(1),
			undefined,
			'historyHandle.get() == [...]'
		);
		
		// remove additional
		historyHandle.removeByObjectId(0);
		
		QUnit.deepEqual(
			historyHandle.get(),
			[],
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(0),
			undefined,
			'historyHandle.get() == [...]'
		);
		QUnit.deepEqual(
			historyHandle.get(1),
			undefined,
			'historyHandle.get() == [...]'
		);

		QUnit.start();
	});

});

